// C Source File
// Created 2/11/2004; 6:21:51 PM

#define USE_TI89              // Compile for TI-89

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define MIN_AMS 100           // Compile for AMS 1.00 or higher

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

#define PMIN 2
#define DMIN 4
#define FMIN 6

int _ti89;

int convert(char str[], int length) {
	int i, a;
	int num = 0;
	int tnum;

	for (i = 0; i < length; i++) {
		if (isdigit(str[i])) {
			tnum = str[i] - '0';
		}
		else {
			printf("Invalid number\n");
			break;
		}
		for (a = 0; a < length-i-1; a++) {
			tnum *= 10;
		}
		num += tnum;
	}
	return num;
}

void _main(void) {
	char ch; /* stores last-inputed character */
	char cnum[3]; /* stores the inputed number as a string */
	int atomnum; /* stores the inputed number */
	int place = 0; /* place in the array cnum */
	int curnum = 0; /* Indicates the amount of electrons used up */
	int curlvl = 0; /* Indicates the place in the electron level */
	short stopflag = 0; /* indicates whether to stop execution of the program or not */
	short skip = 0; /* indicates whether to display the electron levels or not */
	short i; /* used in for loops */

	clrscr();
	/* While stopflag is not set then get input from the user 
	   and output the answer */
	while (!stopflag) {
		/* Input prompt */
		printf(">>> ");

		/* Get the input from the user */
		while ((ch = ngetchx()) != KEY_ENTER) {
			if (ch >= '0' && ch <= '9') {
				printf("%c", ch);
				if (place < 3) {
					cnum[place++] = ch;	
				}
			}
		}
		printf("\n");

		/* Convert the input to a number if there was no input error 
		   and then print the filled electron levels */
		if (place <= 3 && !skip) {
			atomnum = convert(cnum, place);
			if (atomnum > 118 || atomnum < 0) {
				printf("Invalid atomic number\n");
				goto end;
			}
			if (atomnum == 0) {
				return;
			}
			while (atomnum - curnum >= 0) {
				curlvl++;
				/* Get how much of the s level is filled */
				for (i = 1; i < 3; i++) {
					curnum++;
					if (atomnum - curnum < 0) {
						if (i - 1 > 0) {
							printf("%is%i\n", curlvl, i-1);
						}
						goto end;
					}
				}
				printf("%is2 ", curlvl);
				if (atomnum - curnum >= 0) {
					if (curlvl >= FMIN) {
						/* Get how much of the f level is filled */
						for (i = 1; i < 15; i++) {
							curnum++;
							if (atomnum - curnum < 0) {
								if (i - 1 > 0) {
									printf("%if%i\n", curlvl-2, i-1);
								}
								else {
									printf("\n");
								}
								goto end;
							}
						}
						printf("%if14 ", curlvl-2);
					}
					if (curlvl >= DMIN) {
						/* Get how much of the d level is filled */
						for (i = 1; i < 11; i++) {
							curnum++;
							if (atomnum - curnum < 0) {
								if (i - 1 > 0) {
									printf("%id%i\n", curlvl-1, i-1);
								}
								else {
									printf("\n");
								}
								goto end;
							}
						}
						printf("%id10 ", curlvl-1);
					}
					/* Get how much of the p level is filled */
					if (curlvl >= PMIN) {
						for (i = 1; i < 7; i++) {
							curnum++;
							if (atomnum - curnum < 0) {
								if (i - 1 > 0) {
									printf("%ip%i\n", curlvl, i-1);
								}
								else {
									printf("\n");
								}
								goto end;
							}
						}
						printf("%ip6 ", curlvl);
					}	
				}
				printf("\n");
			}
		}
		end:
			curnum = 0;
			place = 0;
			curlvl = 0;
			skip = 0;
	}
	return;
}
